Bug 213947

Summary: krb5-config --libs gssapi omits necessary dependencies
Product: [Fedora] Fedora Reporter: stephane.potvin
Component: krb5Assignee: Nalin Dahyabhai <nalin>
Status: CLOSED WONTFIX QA Contact: Brian Brock <bbrock>
Severity: medium Docs Contact:
Priority: medium    
Version: 8CC: jorton, n3npq, triage
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: bzcl34nup
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2009-01-09 02:00:23 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description stephane.potvin 2006-11-03 16:51:30 EST
Description of problem:
The library krb5support is not specified as a dependency of libneon in libneon.la
This causes linking to fail due to unresolveable symbols
(krb5int_pthread_loaded). Adding -lkrb5support to dependency_libs fixes the problem.

Version-Release number of selected component (if applicable):
neon-0.25.5-5.1.src.rpm

How reproducible:
Try to link a probram using libneon statically (rpm 4.4.1 for example)

Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
Comment 1 Joe Orton 2006-11-06 04:59:36 EST
What's the link failure? This:

dependency_libs=' -L/usr/kerberos/lib64 -lssl -lcrypto -lz -lgssapi_krb5 -lkrb5
-lk5crypto -lcom_err -lresolv -ldl /usr/lib64/libexpat.la'

should be sufficient and correct.
Comment 2 stephane.potvin 2006-11-06 09:38:59 EST
Here's a typical link line and the resultant errors. Adding -lkrb5support to the
dependency_libs line in libneon.la fixed it.
 
gcc -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector
--param=ssp-buffer-size=4 -m32 -march=i386 -mtune=generic
-fasynchronous-unwind-tables -fPIC -DPIC -D_GNU_SOURCE -D_REENTRANT -Wall
-Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wno-char-subscripts -o
rpmb -static build.o rpmb.o  ./build/.libs/librpmbuild.a
-L/var/tmp/rpm-root/usr/lib -L/usr/lib
/home/spotvin/TelcoBridges/eldk/build/ppc-2006-11-06/cross_rpms/rpm/BUILD/rpm-4.4.1/lib/.libs/librpm.a
-L/home/spotvin/TelcoBridges/eldk/build/ppc-2006-11-06/cross_rpms/rpm/BUILD/rpm-4.4.1/zlib
-L/usr/local/lib -L/usr/kerberos/lib ./lib/.libs/librpm.a
/home/spotvin/TelcoBridges/eldk/build/ppc-2006-11-06/cross_rpms/rpm/BUILD/rpm-4.4.1/rpmdb/.libs/librpmdb.a
./rpmdb/.libs/librpmdb.a
/home/spotvin/TelcoBridges/eldk/build/ppc-2006-11-06/cross_rpms/rpm/BUILD/rpm-4.4.1/rpmio/.libs/librpmio.a
/home/spotvin/TelcoBridges/eldk/build/ppc-2006-11-06/cross_rpms/rpm/BUILD/rpm-4.4.1/popt/.libs/libpopt.a
-lelf ./rpmio/.libs/librpmio.a /usr/lib/libbeecrypt.a -lm /usr/lib/libneon.a
-lssl -lcrypto -lz -lgssapi_krb5 -lkrb5 -lk5crypto -lcom_err -lresolv -ldl
/usr/lib/libexpat.a ./popt/.libs/libpopt.a ./zlib/.libs/libz.a -lrt -lpthread
/usr/lib/libkrb5.a(ktbase.o): In function `krb5_kt_register':
(.text+0x225): undefined reference to `krb5int_pthread_loaded'
/usr/lib/libkrb5.a(ktbase.o): In function `krb5_kt_register':
(.text+0x2b1): undefined reference to `krb5int_pthread_loaded'
/usr/lib/libkrb5.a(ktbase.o): In function `krb5_kt_register':
(.text+0x2fd): undefined reference to `krb5int_pthread_loaded'
/usr/lib/libkrb5.a(ktbase.o): In function `krb5_kt_register':
(.text+0x370): undefined reference to `krb5int_pthread_loaded'
/usr/lib/libkrb5.a(ktbase.o): In function `krb5_kt_register':
(.text+0x3bc): undefined reference to `krb5int_pthread_loaded'
/usr/lib/libkrb5.a(ktbase.o):(.text+0x428): more undefined references to
`krb5int_pthread_loaded' follow
[...]
Comment 3 Joe Orton 2006-11-15 07:03:56 EST
`krb5-config --libs gssapi` should really include -lkrb5support in this case;
reassigning to krb5.
Comment 4 Joe Orton 2006-11-15 07:05:40 EST
Background: neon relies on `krb5-config --libs gssapi` to determine how to link
against the gssapi libraries;  to link statically -lkrb5support is also required
so should really be reported.
Comment 5 Nalin Dahyabhai 2006-11-15 10:39:06 EST
I think you're right.
Comment 6 Joe Orton 2007-01-04 10:29:45 EST
*** Bug 221408 has been marked as a duplicate of this bug. ***
Comment 7 Bug Zapper 2008-04-04 00:23:49 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.
http://fedoraproject.org/wiki/LifeCycle/EOL

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 8 Jeff Johnson 2008-04-04 09:20:28 EDT
On f9beta, -lkrb5support is still not included:

$ krb5-config --libs gssapi
-lgssapi_krb5 -lkrb5 -lk5crypto -lcom_err
Comment 9 Nalin Dahyabhai 2008-04-04 10:09:41 EDT
Quite right.  Though we don't have static libraries in the -devel package any
more, so we shouldn't be able to break builds this way.  And given that, I'm a
bit reluctant to make applications which pull in libkrb5 start to have explicit
requirements for dependencies (particularly those like libselinux and
libkeyutils) which they might not be using themselves.  Moving this back to
ASSIGNED so that we don't just auto-close this.
Comment 10 petrosyan 2008-04-04 14:43:02 EDT
Nalin, ASSIGNED bugs will also get auto-closed in 30 days.
Comment 11 Nalin Dahyabhai 2008-04-04 15:00:36 EDT
Moving to F8 then.
Comment 12 Bug Zapper 2008-11-26 02:04:37 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Bug Zapper 2009-01-09 02:00:23 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.